# Records ## List DNS Records `client.dns.records.list(RecordListParamsparams, RequestOptionsoptions?): V4PagePaginationArray` **get** `/zones/{zone_id}/dns_records` List, search, sort, and filter a zones' DNS records. ### Parameters - `params: RecordListParams` - `zone_id: string` Path param: Identifier. - `comment?: Comment` Query param - `absent?: string` If this parameter is present, only records *without* a comment are returned. - `contains?: string` Substring of the DNS record comment. Comment filters are case-insensitive. - `endswith?: string` Suffix of the DNS record comment. Comment filters are case-insensitive. - `exact?: string` Exact value of the DNS record comment. Comment filters are case-insensitive. - `present?: string` If this parameter is present, only records *with* a comment are returned. - `startswith?: string` Prefix of the DNS record comment. Comment filters are case-insensitive. - `content?: Content` Query param - `contains?: string` Substring of the DNS record content. Content filters are case-insensitive. - `endswith?: string` Suffix of the DNS record content. Content filters are case-insensitive. - `exact?: string` Exact value of the DNS record content. Content filters are case-insensitive. - `startswith?: string` Prefix of the DNS record content. Content filters are case-insensitive. - `direction?: SortDirection` Query param: Direction to order DNS records in. - `"asc"` - `"desc"` - `match?: "any" | "all"` Query param: Whether to match all search requirements or at least one (any). If set to `all`, acts like a logical AND between filters. If set to `any`, acts like a logical OR instead. Note that the interaction between tag filters is controlled by the `tag-match` parameter instead. - `"any"` - `"all"` - `name?: Name` Query param - `contains?: string` Substring of the DNS record name. Name filters are case-insensitive. - `endswith?: string` Suffix of the DNS record name. Name filters are case-insensitive. - `exact?: string` Exact value of the DNS record name. Name filters are case-insensitive. - `startswith?: string` Prefix of the DNS record name. Name filters are case-insensitive. - `order?: "type" | "name" | "content" | 2 more` Query param: Field to order DNS records by. - `"type"` - `"name"` - `"content"` - `"ttl"` - `"proxied"` - `page?: number` Query param: Page number of paginated results. - `per_page?: number` Query param: Number of DNS records per page. - `proxied?: boolean` Query param: Whether the record is receiving the performance and security benefits of Cloudflare. - `search?: string` Query param: Allows searching in multiple properties of a DNS record simultaneously. This parameter is intended for human users, not automation. Its exact behavior is intentionally left unspecified and is subject to change in the future. This parameter works independently of the `match` setting. For automated searches, please use the other available parameters. - `tag?: Tag` Query param - `absent?: string` Name of a tag which must *not* be present on the DNS record. Tag filters are case-insensitive. - `contains?: string` A tag and value, of the form `:`. The API will only return DNS records that have a tag named `` whose value contains ``. Tag filters are case-insensitive. - `endswith?: string` A tag and value, of the form `:`. The API will only return DNS records that have a tag named `` whose value ends with ``. Tag filters are case-insensitive. - `exact?: string` A tag and value, of the form `:`. The API will only return DNS records that have a tag named `` whose value is ``. Tag filters are case-insensitive. - `present?: string` Name of a tag which must be present on the DNS record. Tag filters are case-insensitive. - `startswith?: string` A tag and value, of the form `:`. The API will only return DNS records that have a tag named `` whose value starts with ``. Tag filters are case-insensitive. - `tag_match?: "any" | "all"` Query param: Whether to match all tag search requirements or at least one (any). If set to `all`, acts like a logical AND between tag filters. If set to `any`, acts like a logical OR instead. Note that the regular `match` parameter is still used to combine the resulting condition with other filters that aren't related to tags. - `"any"` - `"all"` - `type?: "A" | "AAAA" | "CAA" | 18 more` Query param: Record type. - `"A"` - `"AAAA"` - `"CAA"` - `"CERT"` - `"CNAME"` - `"DNSKEY"` - `"DS"` - `"HTTPS"` - `"LOC"` - `"MX"` - `"NAPTR"` - `"NS"` - `"OPENPGPKEY"` - `"PTR"` - `"SMIMEA"` - `"SRV"` - `"SSHFP"` - `"SVCB"` - `"TLSA"` - `"TXT"` - `"URI"` ### Returns - `RecordResponse = A | AAAA | CNAME | 18 more` - `A extends ARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `AAAA extends AAAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CNAME extends CNAMERecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `MX extends MXRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NS extends NSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `Openpgpkey` - `id: string` Identifier. - `comment: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content: string` A single Base64-encoded OpenPGP Transferable Public Key (RFC 4880 Section 11.1) - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `name: string` Complete DNS record name, including the zone name, in Punycode. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `proxied: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `number` - `1` - `1` - `type: "OPENPGPKEY"` Record type. - `"OPENPGPKEY"` - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `PTR extends PTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `TXT extends TXTRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CAA extends CAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CERT extends CERTRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `DNSKEY extends DNSKEYRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `DS extends DSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `HTTPS extends HTTPSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `LOC extends LOCRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NAPTR extends NAPTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SMIMEA extends SMIMEARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SRV extends SRVRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SSHFP extends SSHFPRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SVCB extends SVCBRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `TLSA extends TLSARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `URI extends URIRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); // Automatically fetches more pages as needed. for await (const recordResponse of client.dns.records.list({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353', })) { console.log(recordResponse); } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": [ { "name": "example.com", "ttl": 3600, "type": "A", "comment": "Domain verification record", "content": "198.51.100.4", "private_routing": true, "proxied": true, "settings": { "ipv4_only": true, "ipv6_only": true }, "tags": [ "owner:dns-team" ], "id": "023e105f4ecef8ad9ca31a8372d0c353", "created_on": "2014-01-01T05:20:00.12345Z", "meta": {}, "modified_on": "2014-01-01T05:20:00.12345Z", "proxiable": true, "comment_modified_on": "2024-01-01T05:20:00.12345Z", "tags_modified_on": "2025-01-01T05:20:00.12345Z" } ], "result_info": { "count": 1, "page": 1, "per_page": 20, "total_count": 2000, "total_pages": 100 } } ``` ## DNS Record Details `client.dns.records.get(stringdnsRecordId, RecordGetParamsparams, RequestOptionsoptions?): RecordResponse` **get** `/zones/{zone_id}/dns_records/{dns_record_id}` DNS Record Details ### Parameters - `dnsRecordId: string` Identifier. - `params: RecordGetParams` - `zone_id: string` Identifier. ### Returns - `RecordResponse = A | AAAA | CNAME | 18 more` - `A extends ARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `AAAA extends AAAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CNAME extends CNAMERecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `MX extends MXRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NS extends NSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `Openpgpkey` - `id: string` Identifier. - `comment: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content: string` A single Base64-encoded OpenPGP Transferable Public Key (RFC 4880 Section 11.1) - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `name: string` Complete DNS record name, including the zone name, in Punycode. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `proxied: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `number` - `1` - `1` - `type: "OPENPGPKEY"` Record type. - `"OPENPGPKEY"` - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `PTR extends PTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `TXT extends TXTRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CAA extends CAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CERT extends CERTRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `DNSKEY extends DNSKEYRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `DS extends DSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `HTTPS extends HTTPSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `LOC extends LOCRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NAPTR extends NAPTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SMIMEA extends SMIMEARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SRV extends SRVRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SSHFP extends SSHFPRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SVCB extends SVCBRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `TLSA extends TLSARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `URI extends URIRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const recordResponse = await client.dns.records.get('023e105f4ecef8ad9ca31a8372d0c353', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353', }); console.log(recordResponse); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "name": "example.com", "ttl": 3600, "type": "A", "comment": "Domain verification record", "content": "198.51.100.4", "private_routing": true, "proxied": true, "settings": { "ipv4_only": true, "ipv6_only": true }, "tags": [ "owner:dns-team" ], "id": "023e105f4ecef8ad9ca31a8372d0c353", "created_on": "2014-01-01T05:20:00.12345Z", "meta": {}, "modified_on": "2014-01-01T05:20:00.12345Z", "proxiable": true, "comment_modified_on": "2024-01-01T05:20:00.12345Z", "tags_modified_on": "2025-01-01T05:20:00.12345Z" } } ``` ## Create DNS Record `client.dns.records.create(RecordCreateParamsparams, RequestOptionsoptions?): RecordResponse` **post** `/zones/{zone_id}/dns_records` Create a new DNS record for a zone. Notes: - A/AAAA records cannot exist on the same name as CNAME records. - NS records cannot exist on the same name as any other record type. - Domain names are always represented in Punycode, even if Unicode characters were used when creating the record. ### Parameters - `RecordCreateParams = ARecord | AAAARecord | CNAMERecord | 18 more` - `RecordCreateParamsBase` - `ARecord extends RecordCreateParamsBase` - `AAAARecord extends RecordCreateParamsBase` - `CNAMERecord extends RecordCreateParamsBase` - `MXRecord extends RecordCreateParamsBase` - `NSRecord extends RecordCreateParamsBase` - `DNSRecordsOpenpgpkeyRecord extends RecordCreateParamsBase` - `PTRRecord extends RecordCreateParamsBase` - `TXTRecord extends RecordCreateParamsBase` - `CAARecord extends RecordCreateParamsBase` - `CERTRecord extends RecordCreateParamsBase` - `DNSKEYRecord extends RecordCreateParamsBase` - `DSRecord extends RecordCreateParamsBase` - `HTTPSRecord extends RecordCreateParamsBase` - `LOCRecord extends RecordCreateParamsBase` - `NAPTRRecord extends RecordCreateParamsBase` - `SMIMEARecord extends RecordCreateParamsBase` - `SRVRecord extends RecordCreateParamsBase` - `SSHFPRecord extends RecordCreateParamsBase` - `SVCBRecord extends RecordCreateParamsBase` - `TLSARecord extends RecordCreateParamsBase` - `URIRecord extends RecordCreateParamsBase` ### Returns - `RecordResponse = A | AAAA | CNAME | 18 more` - `A extends ARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `AAAA extends AAAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CNAME extends CNAMERecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `MX extends MXRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NS extends NSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `Openpgpkey` - `id: string` Identifier. - `comment: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content: string` A single Base64-encoded OpenPGP Transferable Public Key (RFC 4880 Section 11.1) - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `name: string` Complete DNS record name, including the zone name, in Punycode. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `proxied: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `number` - `1` - `1` - `type: "OPENPGPKEY"` Record type. - `"OPENPGPKEY"` - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `PTR extends PTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `TXT extends TXTRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CAA extends CAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CERT extends CERTRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `DNSKEY extends DNSKEYRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `DS extends DSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `HTTPS extends HTTPSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `LOC extends LOCRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NAPTR extends NAPTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SMIMEA extends SMIMEARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SRV extends SRVRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SSHFP extends SSHFPRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SVCB extends SVCBRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `TLSA extends TLSARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `URI extends URIRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const recordResponse = await client.dns.records.create({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353', name: 'example.com', ttl: 3600, type: 'A', }); console.log(recordResponse); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "name": "example.com", "ttl": 3600, "type": "A", "comment": "Domain verification record", "content": "198.51.100.4", "private_routing": true, "proxied": true, "settings": { "ipv4_only": true, "ipv6_only": true }, "tags": [ "owner:dns-team" ], "id": "023e105f4ecef8ad9ca31a8372d0c353", "created_on": "2014-01-01T05:20:00.12345Z", "meta": {}, "modified_on": "2014-01-01T05:20:00.12345Z", "proxiable": true, "comment_modified_on": "2024-01-01T05:20:00.12345Z", "tags_modified_on": "2025-01-01T05:20:00.12345Z" } } ``` ## Overwrite DNS Record `client.dns.records.update(stringdnsRecordId, RecordUpdateParamsparams, RequestOptionsoptions?): RecordResponse` **put** `/zones/{zone_id}/dns_records/{dns_record_id}` Overwrite an existing DNS record. Notes: - A/AAAA records cannot exist on the same name as CNAME records. - NS records cannot exist on the same name as any other record type. - Domain names are always represented in Punycode, even if Unicode characters were used when creating the record. ### Parameters - `dnsRecordId: string` Identifier. - `RecordUpdateParams = ARecord | AAAARecord | CNAMERecord | 18 more` - `RecordUpdateParamsBase` - `ARecord extends RecordUpdateParamsBase` - `AAAARecord extends RecordUpdateParamsBase` - `CNAMERecord extends RecordUpdateParamsBase` - `MXRecord extends RecordUpdateParamsBase` - `NSRecord extends RecordUpdateParamsBase` - `DNSRecordsOpenpgpkeyRecord extends RecordUpdateParamsBase` - `PTRRecord extends RecordUpdateParamsBase` - `TXTRecord extends RecordUpdateParamsBase` - `CAARecord extends RecordUpdateParamsBase` - `CERTRecord extends RecordUpdateParamsBase` - `DNSKEYRecord extends RecordUpdateParamsBase` - `DSRecord extends RecordUpdateParamsBase` - `HTTPSRecord extends RecordUpdateParamsBase` - `LOCRecord extends RecordUpdateParamsBase` - `NAPTRRecord extends RecordUpdateParamsBase` - `SMIMEARecord extends RecordUpdateParamsBase` - `SRVRecord extends RecordUpdateParamsBase` - `SSHFPRecord extends RecordUpdateParamsBase` - `SVCBRecord extends RecordUpdateParamsBase` - `TLSARecord extends RecordUpdateParamsBase` - `URIRecord extends RecordUpdateParamsBase` ### Returns - `RecordResponse = A | AAAA | CNAME | 18 more` - `A extends ARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `AAAA extends AAAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CNAME extends CNAMERecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `MX extends MXRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NS extends NSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `Openpgpkey` - `id: string` Identifier. - `comment: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content: string` A single Base64-encoded OpenPGP Transferable Public Key (RFC 4880 Section 11.1) - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `name: string` Complete DNS record name, including the zone name, in Punycode. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `proxied: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `number` - `1` - `1` - `type: "OPENPGPKEY"` Record type. - `"OPENPGPKEY"` - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `PTR extends PTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `TXT extends TXTRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CAA extends CAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CERT extends CERTRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `DNSKEY extends DNSKEYRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `DS extends DSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `HTTPS extends HTTPSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `LOC extends LOCRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NAPTR extends NAPTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SMIMEA extends SMIMEARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SRV extends SRVRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SSHFP extends SSHFPRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SVCB extends SVCBRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `TLSA extends TLSARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `URI extends URIRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const recordResponse = await client.dns.records.update('023e105f4ecef8ad9ca31a8372d0c353', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353', name: 'example.com', ttl: 3600, type: 'A', }); console.log(recordResponse); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "name": "example.com", "ttl": 3600, "type": "A", "comment": "Domain verification record", "content": "198.51.100.4", "private_routing": true, "proxied": true, "settings": { "ipv4_only": true, "ipv6_only": true }, "tags": [ "owner:dns-team" ], "id": "023e105f4ecef8ad9ca31a8372d0c353", "created_on": "2014-01-01T05:20:00.12345Z", "meta": {}, "modified_on": "2014-01-01T05:20:00.12345Z", "proxiable": true, "comment_modified_on": "2024-01-01T05:20:00.12345Z", "tags_modified_on": "2025-01-01T05:20:00.12345Z" } } ``` ## Update DNS Record `client.dns.records.edit(stringdnsRecordId, RecordEditParamsparams, RequestOptionsoptions?): RecordResponse` **patch** `/zones/{zone_id}/dns_records/{dns_record_id}` Update an existing DNS record. Notes: - A/AAAA records cannot exist on the same name as CNAME records. - NS records cannot exist on the same name as any other record type. - Domain names are always represented in Punycode, even if Unicode characters were used when creating the record. ### Parameters - `dnsRecordId: string` Identifier. - `RecordEditParams = ARecord | AAAARecord | CNAMERecord | 18 more` - `RecordEditParamsBase` - `ARecord extends RecordEditParamsBase` - `AAAARecord extends RecordEditParamsBase` - `CNAMERecord extends RecordEditParamsBase` - `MXRecord extends RecordEditParamsBase` - `NSRecord extends RecordEditParamsBase` - `DNSRecordsOpenpgpkeyRecord extends RecordEditParamsBase` - `PTRRecord extends RecordEditParamsBase` - `TXTRecord extends RecordEditParamsBase` - `CAARecord extends RecordEditParamsBase` - `CERTRecord extends RecordEditParamsBase` - `DNSKEYRecord extends RecordEditParamsBase` - `DSRecord extends RecordEditParamsBase` - `HTTPSRecord extends RecordEditParamsBase` - `LOCRecord extends RecordEditParamsBase` - `NAPTRRecord extends RecordEditParamsBase` - `SMIMEARecord extends RecordEditParamsBase` - `SRVRecord extends RecordEditParamsBase` - `SSHFPRecord extends RecordEditParamsBase` - `SVCBRecord extends RecordEditParamsBase` - `TLSARecord extends RecordEditParamsBase` - `URIRecord extends RecordEditParamsBase` ### Returns - `RecordResponse = A | AAAA | CNAME | 18 more` - `A extends ARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `AAAA extends AAAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CNAME extends CNAMERecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `MX extends MXRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NS extends NSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `Openpgpkey` - `id: string` Identifier. - `comment: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content: string` A single Base64-encoded OpenPGP Transferable Public Key (RFC 4880 Section 11.1) - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `name: string` Complete DNS record name, including the zone name, in Punycode. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `proxied: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `number` - `1` - `1` - `type: "OPENPGPKEY"` Record type. - `"OPENPGPKEY"` - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `PTR extends PTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `TXT extends TXTRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CAA extends CAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CERT extends CERTRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `DNSKEY extends DNSKEYRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `DS extends DSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `HTTPS extends HTTPSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `LOC extends LOCRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NAPTR extends NAPTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SMIMEA extends SMIMEARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SRV extends SRVRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SSHFP extends SSHFPRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SVCB extends SVCBRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `TLSA extends TLSARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `URI extends URIRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: unknown` Extra Cloudflare-specific information about the record. - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const recordResponse = await client.dns.records.edit('023e105f4ecef8ad9ca31a8372d0c353', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353', name: 'example.com', ttl: 3600, type: 'A', }); console.log(recordResponse); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "name": "example.com", "ttl": 3600, "type": "A", "comment": "Domain verification record", "content": "198.51.100.4", "private_routing": true, "proxied": true, "settings": { "ipv4_only": true, "ipv6_only": true }, "tags": [ "owner:dns-team" ], "id": "023e105f4ecef8ad9ca31a8372d0c353", "created_on": "2014-01-01T05:20:00.12345Z", "meta": {}, "modified_on": "2014-01-01T05:20:00.12345Z", "proxiable": true, "comment_modified_on": "2024-01-01T05:20:00.12345Z", "tags_modified_on": "2025-01-01T05:20:00.12345Z" } } ``` ## Delete DNS Record `client.dns.records.delete(stringdnsRecordId, RecordDeleteParamsparams, RequestOptionsoptions?): RecordDeleteResponse` **delete** `/zones/{zone_id}/dns_records/{dns_record_id}` Delete DNS Record ### Parameters - `dnsRecordId: string` Identifier. - `params: RecordDeleteParams` - `zone_id: string` Identifier. ### Returns - `RecordDeleteResponse` - `id?: string` Identifier. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const record = await client.dns.records.delete('023e105f4ecef8ad9ca31a8372d0c353', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353', }); console.log(record.id); ``` #### Response ```json { "result": { "id": "023e105f4ecef8ad9ca31a8372d0c353" } } ``` ## Export DNS Records `client.dns.records.export(RecordExportParamsparams, RequestOptionsoptions?): RecordExportResponse` **get** `/zones/{zone_id}/dns_records/export` You can export your [BIND config](https://en.wikipedia.org/wiki/Zone_file "Zone file") through this endpoint. See [the documentation](https://developers.cloudflare.com/dns/manage-dns-records/how-to/import-and-export/ "Import and export records") for more information. ### Parameters - `params: RecordExportParams` - `zone_id: string` Identifier. ### Returns - `RecordExportResponse = string` Exported BIND zone file. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const response = await client.dns.records.export({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353' }); console.log(response); ``` ## Import DNS Records `client.dns.records.import(RecordImportParamsparams, RequestOptionsoptions?): RecordImportResponse` **post** `/zones/{zone_id}/dns_records/import` You can upload your [BIND config](https://en.wikipedia.org/wiki/Zone_file "Zone file") through this endpoint. It assumes that cURL is called from a location with bind_config.txt (valid BIND config) present. See [the documentation](https://developers.cloudflare.com/dns/manage-dns-records/how-to/import-and-export/ "Import and export records") for more information. ### Parameters - `params: RecordImportParams` - `zone_id: string` Path param: Identifier. - `file: string` Body param: BIND config to import. **Tip:** When using cURL, a file can be uploaded using `--form 'file=@bind_config.txt'`. - `proxied?: string` Body param: Whether or not proxiable records should receive the performance and security benefits of Cloudflare. The value should be either `true` or `false`. ### Returns - `RecordImportResponse` - `recs_added?: number` Number of DNS records added. - `total_records_parsed?: number` Total number of DNS records parsed. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const response = await client.dns.records.import({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353', file: 'www.example.com. 300 IN A 127.0.0.1', }); console.log(response.recs_added); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "recs_added": 5, "total_records_parsed": 5 } } ``` ## Scan DNS Records `client.dns.records.scan(RecordScanParamsparams, RequestOptionsoptions?): RecordScanResponse` **post** `/zones/{zone_id}/dns_records/scan` Scan for common DNS records on your domain and automatically add them to your zone. Useful if you haven't updated your nameservers yet. ### Parameters - `params: RecordScanParams` - `zone_id: string` Path param: Identifier. - `body: unknown` Body param ### Returns - `RecordScanResponse` - `recs_added?: number` Number of DNS records added. - `total_records_parsed?: number` Total number of DNS records parsed. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const response = await client.dns.records.scan({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353', body: {}, }); console.log(response.recs_added); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "recs_added": 5, "total_records_parsed": 5 } } ``` ## Trigger DNS Record Scan `client.dns.records.scanTrigger(RecordScanTriggerParamsparams, RequestOptionsoptions?): RecordScanTriggerResponse` **post** `/zones/{zone_id}/dns_records/scan/trigger` Initiates an asynchronous scan for common DNS records on your domain. Note that this **does not** automatically add records to your zone. The scan runs in the background, and results can be reviewed later using the `/scan/review` endpoints. Useful if you haven't updated your nameservers yet. ### Parameters - `params: RecordScanTriggerParams` - `zone_id: string` Identifier. ### Returns - `RecordScanTriggerResponse` - `errors: Array` - `code: number` - `message: string` - `documentation_url?: string` - `source?: Source` - `pointer?: string` - `messages: Array` - `code: number` - `message: string` - `documentation_url?: string` - `source?: Source` - `pointer?: string` - `success: true` Whether the API call was successful. - `true` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const response = await client.dns.records.scanTrigger({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353', }); console.log(response.errors); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true } ``` ## Review Scanned DNS Records `client.dns.records.scanReview(RecordScanReviewParamsparams, RequestOptionsoptions?): RecordScanReviewResponse` **post** `/zones/{zone_id}/dns_records/scan/review` Accept or reject DNS records found by the DNS records scan. Accepted records will be permanently added to the zone, while rejected records will be permanently deleted. ### Parameters - `params: RecordScanReviewParams` - `zone_id: string` Path param: Identifier. - `accepts?: Array` Body param - `ARecord` - `name: string` Complete DNS record name, including the zone name, in Punycode. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `number` - `1` - `1` - `type: "A"` Record type. - `"A"` - `comment?: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content?: string` A valid IPv4 address. - `private_routing?: boolean` Enables private network routing to the origin. - `proxied?: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings?: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags?: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `AAAARecord` - `name: string` Complete DNS record name, including the zone name, in Punycode. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `type: "AAAA"` Record type. - `"AAAA"` - `comment?: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content?: string` A valid IPv6 address. - `private_routing?: boolean` Enables private network routing to the origin. - `proxied?: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings?: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags?: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `CNAMERecord` - `name: string` Complete DNS record name, including the zone name, in Punycode. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `type: "CNAME"` Record type. - `"CNAME"` - `comment?: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content?: string` A valid hostname. Must not match the record's name. - `proxied?: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings?: Settings` Settings for the DNS record. - `flatten_cname?: boolean` If enabled, causes the CNAME record to be resolved externally and the resulting address records (e.g., A and AAAA) to be returned instead of the CNAME record itself. This setting is unavailable for proxied records, since they are always flattened. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags?: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `MXRecord` - `name: string` Complete DNS record name, including the zone name, in Punycode. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `type: "MX"` Record type. - `"MX"` - `comment?: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content?: string` A valid mail server hostname. - `priority?: number` Required for MX and URI records; ignored for other record types (but may still be returned by the API). Records with lower priorities are preferred. This field is to be deprecated in favor of the priority field within the data map. - `proxied?: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings?: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags?: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `NSRecord` - `name: string` Complete DNS record name, including the zone name, in Punycode. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `type: "NS"` Record type. - `"NS"` - `comment?: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content?: string` A valid name server host name. - `proxied?: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings?: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags?: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `DNSRecordsOpenpgpkeyRecord` - `name: string` Complete DNS record name, including the zone name, in Punycode. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `type: "OPENPGPKEY"` Record type. - `"OPENPGPKEY"` - `comment?: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content?: string` A single Base64-encoded OpenPGP Transferable Public Key (RFC 4880 Section 11.1) - `proxied?: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings?: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags?: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `PTRRecord` - `name: string` Complete DNS record name, including the zone name, in Punycode. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `type: "PTR"` Record type. - `"PTR"` - `comment?: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content?: string` Domain name pointing to the address. - `proxied?: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings?: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags?: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `TXTRecord` - `name: string` Complete DNS record name, including the zone name, in Punycode. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `type: "TXT"` Record type. - `"TXT"` - `comment?: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content?: string` Text content for the record. The content must consist of quoted "character strings" (RFC 1035), each with a length of up to 255 bytes. Strings exceeding this allowed maximum length are automatically split. Learn more at . - `proxied?: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings?: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags?: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `CAARecord` - `name: string` Complete DNS record name, including the zone name, in Punycode. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `type: "CAA"` Record type. - `"CAA"` - `comment?: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content?: string` Formatted CAA content. See 'data' to set CAA properties. - `data?: Data` Components of a CAA record. - `flags?: number` Flags for the CAA record. - `tag?: string` Name of the property controlled by this record (e.g.: issue, issuewild, iodef). - `value?: string` Value of the record. This field's semantics depend on the chosen tag. - `proxied?: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings?: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags?: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `CERTRecord` - `name: string` Complete DNS record name, including the zone name, in Punycode. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `type: "CERT"` Record type. - `"CERT"` - `comment?: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content?: string` Formatted CERT content. See 'data' to set CERT properties. - `data?: Data` Components of a CERT record. - `algorithm?: number` Algorithm. - `certificate?: string` Certificate. - `key_tag?: number` Key Tag. - `type?: number` Type. - `proxied?: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings?: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags?: Array` Custom tags for the DNS record. This fiel
[...]
